package Lento::Debuggable;
use Data::Dumper;
use Storable;
use Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(DEBUG LOG);

#my loggingbits = 0xfffffff;

sub set_debug_level {
  my $class = shift;
  my $level = shift;
  ${"${class}::level"} = $level;   # this sets the level scalar symbol
  # in the package $class.
}

sub get_debug_level {
  my $class = shift;
  return ${"${class}::level"};
}

sub InterCon { 
    my $hdr = shift;
    push @Debuggable::intercons, $hdr;

#    $hdr->{connection}->sendreply($hdr->{token}, 0, undef);

}

sub LOG { 
     my $msg = sprintf($_[0], @_[1..$#_]);
     print $msg;
     foreach my $hdr ( @Debuggable::intercons ) {
	 $hdr->{connection}->senddata($hdr->{token}, $msg);
     }
} 

sub DEBUG {
  my ($class, $file, $line) = caller;
  my @args =  @_;
  $args[0] =  "[$file, line $line] " . $args[0];

  # this next code block -really- confuses xemacs
  if (${"${class}::level"}) {
      printf @args if ((${"${class}::level"} || $::global_debug) &&
                       ${"${class}::level"} != -1);
  } else {
      printf @args if ($::global_debug);
  }    
}

sub test {
    $::global_debug =1;
    DEBUG "Hello world\n";
    LOG "info", "Hello world %s\n", "hozer";
}

# test;
1;
