package Lento::Downcall;

my $RELEASE_JOURNAL= 51;
my $MARK           = 52;

my $PRESTO_ATTR	 = 0x00000001; # attributes cached
my $PRESTO_DATA	 = 0x00000002;  # data cached
my $PRESTO_VOLROOT = 0x00000004;  # this dentry is root of volume 
my $PRESTO_HASPERMIT = 0x00000008;  #we have a permit to WB

sub release ($) {
    my $class = shift;

    my $msg = pack "iii", $RELEASE_JOURNAL, 0, 0;
    Lento::Psdev->write($msg, length($msg)) || die "Psdev->write";
}

sub mark ($$$) {
    my $path = shift;
    my $andflag = shift;
    my $orflag = shift;
    my $len = length($path) + 1;

    my $msg = pack "iiiiia$len", $MARK, 0, 0, $andflag, $orflag, $path, 0;

    Psdev->write($msg, length($msg)) || die;
}

sub revoke_permit ($) {
    my $class = shift;
    my $path = shift;
    mark($path, ~$PRESTO_HASPERMIT, 0);
}

sub revoke_data ($$) {
    my $class = shift;
    my $path = shift;
    mark($path, ~$PRESTO_HASDATA, 0);
}

sub revoke_attr ($$) {
    my $class = shift;
    my $path = shift;
    mark($path, ~$PRESTO_HASATTR, 0);
}

sub setvolroot ($$) {
    my $class = shift;
    my $path = shift;

    mark($path, 0, $PRESTO_ISVOLROOT);
}

1;
