package Lento::InControl;

use strict;
use Lento::Debuggable;

@Lento::InControl::ISA = qw(Lento::Debuggable);
$Lento::InControl::level = 0;

sub Echo ($$) {
    my $hdr = shift;
    my $echostring = shift;

    DEBUG "Got $echostring\n";

    $hdr->{connection}->sendreply($hdr->{token}, 0, $echostring);
}

sub DumpFsdb ($) {
    my $hdr = shift;
    my $str = ("[Fsdb]: Root: " . $::fsdb->{root} . " device: " .
	       $::fsdb->{device} . "\n");
    my $entry;

    for $entry (sort keys %{$::fsdb->{fso_by_path}}) {
	$str .= $::fsdb->{fso_by_path}->{$entry}->printme();
    }

    $hdr->{connection}->sendreply($hdr->{token}, 0, $str);
}

sub Debug ($$$) {
    my $hdr = shift;
    my $subsys = shift;
    my $value = shift;
    my $command = sprintf "\$%s::level = %d;", $subsys, $value;

    DEBUG("Eval'd %s\n", $command);

    my $rc = eval $command;

    LOG "info", "It worked\n";
    $hdr->{connection}->sendreply($hdr->{token}, $@, undef);
}

sub Release ($) {
    my $hdr = shift;

    Downcall->release();
}

sub FlushPermit ($$) {
    my $hdr = shift;
    my $path = shift;

    Downcall->revoke_permit($path);
}

sub FlushAttr ($$) {
    my $hdr = shift;
    my $path = shift;

    Downcall->revoke_attr($path);
}

sub FlushData ($$) {
    my $hdr = shift;
    my $path = shift;

    Downcall->revoke_data($path);
}

1;
