package Lento::Server;
use strict;
use POE;
use Lento::Connector;
use Lento::Connection;
use Lento::Debuggable;

@Lento::Server::ISA = qw(Lento::Debuggable);
$Lento::Server::level = 0;

sub new {
    my $class = shift || die;
    my $self = {};
    bless $self, $class;

    $self->{name} = shift;
    $self->{port} = shift || die "Must pass port";
    $self->{vols} = {};

    $self->{connection} = new Lento::Connection();
    $self->{connector} = new Lento::Connector($self->{connection}, 
				       $self->{name}, 
				       $self->{port});

    return $self;
}

sub name ($) {
    my $self = shift;
    $self->{name};
}

sub pushvol ($$) {
    my $self = shift;
    my $vol = shift;
    $self->{vols}->{$vol->name} = $vol;
}

sub printme ($) {
    my $self = shift;
    my $result;
    my $volname;
    $result = "Server \"$self->{name}\" holds volumes: ";
    foreach $volname ( keys %{$self->{vols}} ) { 
	$result .= $self->{vols}->{$volname}->name . " "; 
    };
    $result .= "\n";

    return $result;
}

1;

