package Lento::Serverdb;
use strict;
use Lento::Debuggable;
use Lento::Server;

@Lento::Serverdb::ISA = qw(Lento::Debuggable);
$Lento::Serverdb::level = 0;

sub new ($) {
    my $class = shift;
    my $self = {};
    
    $self->{srv_by_name} = {};

    bless $self;
}

sub find_by_name ($$) {
    my $self = shift;
    my $name = shift;

    return $self->{srv_by_name}->{$name};
}

sub add($$) {
    my $self = shift; 
    my $server = shift;

    DEBUG "Adding server \"$server->{name}\"\n";
    $self->{srv_by_name}->{$server->{name}} = $server;
}

sub printdb($) {
    my $self = shift;
    my $result; 
    foreach my $name (keys %{$self->{srv_by_name}}) {
	$result .= $self->{srv_by_name}->{$name}->printme();
    }
    $result;
}

1;
