#!/usr/bin/perl
use strict;

use Getopt::Long;
use Psdev;
use Debuggable;
use Downcall;
use POE qw(Wheel::SocketFactory Wheel::ReadWrite Driver::SysRW Filter::Line);

package Bootstrap;

use strict;

use Debuggable;
use Getopt::Long;
use POE::Session;
use ReqDispatcher;

$::global_debug = 1;

@Bootstrap::ISA = qw(Debuggable);

sub new {
    my $class = shift;
    my $self = bless {}, $class;
    
    $self->{name} = "Bootstrap";

    DEBUG "Bootstrapper started: $self: hi!\n";
    new POE::Session($self, [ '_start' , '_stop' ]);

    return undef;
}

sub _start {
    my $object = $_[OBJECT];

    # open the kernel request channel
    $::psdev = Psdev->new();
    $::psdev->open();
    # Flush any kernel pages that are left over from any old intermezzos
    # XX this should only be done when we are ready for service.
    Downcall->release();

    $::dispatcher = ReqDispatcher->new($::psdev, 1);
}

sub _stop {
    my $object = $_[OBJECT];
    print "$object has stopped, bye world...\n";
    exit;
}


#######################################################
package main;
@::ISA = qw(Debuggable);
$::level = 0;

print "Ready for service.\n";
Bootstrap->new();
$poe_kernel->run();
