#!/usr/bin/perl
use strict;

use Getopt::Long;
use Vldb;
use Serverdb;
use Debuggable;

$::global_debug = 1;
my ($servername, $runserver, $nopresto, $debugging, $root, $device, $mirror);

# startup options
my $debugging;
GetOptions("d=s" => \$debugging, "root=s" => \$::root,
	   "vldb=s" => \$::vldb_file, "testpath=s" => \$::testpath)
  || die "Getoptions";

$::vldb_file = "voldb" unless $::vldb_file;
$::global_debug = 1 if $debugging;
# root of file system
$::root = "/izo" unless $::root;
$servername = "localhost" unless $servername;
$::mirror = "/tmp/dvto" unless $::mirror;
$device = "/dev/loop0" unless $device;
$::testpath = $::root unless $::testpath;

# Serverdb
$::serverdb = Serverdb->new();
#initialize volume database
$::vldb = Vldb->new();

print "\n" . $::serverdb->printdb() . "\n" . $::vldb->printdb() . "\n";

my $vol = $::vldb->find_by_path($::testpath);
if ($vol) {
    print "$::testpath is in volume " . $vol->name() . "\n";
} else {
    print "$::testpath is not in a volume.\n";
}
